
import java.util.Stack;

/* Contexto de gerao de cdigo para o mtodo atual */
class CodeGen {
	SymbolTable st;       // nvel de escopo atual!
	int temp;             // primeiro registrador livre, para temporrios
	int label;            // primeiro label livre
	StringBuilder out;    // sada para o cdigo do mtodo atual
	Stack<Integer> exits; // pilha de sadas de lao, para break 
	
	CodeGen(int temp) {
		label = 0;
		this.temp = temp;
		out = new StringBuilder();
		exits = new Stack<Integer>();
	}
	
	String label(int lab) {
		return "label" + lab;
	}
	
	void emitLabel(int lab) {
		out.append(label(lab) + ":\n");
	}

	void emit(String s) {
		out.append(s + "\n");
	}

	void emitJmp(int lab) {
		emit("JMP", label(lab));
	}
	
	void emit(String op, String arg1, String arg2, String arg3) {
		out.append("  " + op + " " + arg1 + " " + arg2 + " " + arg3 + "\n");
	}

	void emit(String op, String arg1, String arg2) {
		out.append("  " + op + " " + arg1 + " " + arg2 + "\n");
	}

	void emit(String op, String arg1) {
		out.append("  " + op + " " + arg1 + "\n");
	}			

 	Loc gettemp() {
 		return new Loc(temp++);
 	}
}
