
__GOSSIP_CLASSES = {}

function __GOSSIP_CLASS(class)
  __GOSSIP_CLASSES[class] = {}
end

function __GOSSIP_METHOD(class, methodname, method)
  __GOSSIP_CLASSES[class][methodname] = method
end

function __GOSSIP_NEW(class, ...)
  local class = __GOSSIP_CLASSES[class]
  local obj = setmetatable({}, { __index = class })
  if obj.init then
    obj:init(...)
  end
  return obj
end

function __GOSSIP_RUN(class)
  local obj = __GOSSIP_NEW(class)
  obj:main()
end

__GOSSIP_CLASS("Array")

__GOSSIP_METHOD("Array", "init", function (self, n)
                                   self.n = n
                                 end)

__GOSSIP_METHOD("Array", "length", function (self)
                                     return self.n
                                   end)

getmetatable("foo").__index.tonumber = function (self)
                                         return tonumber(self)
                                       end

out = {
  print = function (self, ...)
            print(...)
          end
}

_G["in"] = {
  readline = function (self, ...)
               return io.read("*l")
             end
}

dofile(...)

